// DESIREView.cpp : implementation of the CDESIREView class

#include "stdafx.h"
#include "DESIRE.h"

#include "DESIREDoc.h"
#include "DESIREView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDESIREView

IMPLEMENT_DYNCREATE(CDESIREView, CEditView)

BEGIN_MESSAGE_MAP(CDESIREView, CEditView)
	//{{AFX_MSG_MAP(CDESIREView)
	ON_COMMAND(ID_TRANSFER_OK, OnTransferOk)
	ON_COMMAND(ID_TRANSFER_ADDFILE, OnTransferAddfile)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CEditView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDESIREView construction/destruction

CDESIREView::CDESIREView()
{
	// TODO: add construction code here

}

CDESIREView::~CDESIREView()
{
}

BOOL CDESIREView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	BOOL bPreCreated = CEditView::PreCreateWindow(cs);
	cs.style &= ~(ES_AUTOHSCROLL|WS_HSCROLL);	// Enable word-wrapping

	return bPreCreated;
}

/////////////////////////////////////////////////////////////////////////////
// CDESIREView drawing

void CDESIREView::OnDraw(CDC* pDC)
{
	CDESIREDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CDESIREView printing

BOOL CDESIREView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default CEditView preparation
	return CEditView::OnPreparePrinting(pInfo);
}

void CDESIREView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// Default CEditView begin printing.
	CEditView::OnBeginPrinting(pDC, pInfo);
}

void CDESIREView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// Default CEditView end printing
	CEditView::OnEndPrinting(pDC, pInfo);
}

/////////////////////////////////////////////////////////////////////////////
// CDESIREView diagnostics

#ifdef _DEBUG
void CDESIREView::AssertValid() const
{
	CEditView::AssertValid();
}

void CDESIREView::Dump(CDumpContext& dc) const
{
	CEditView::Dump(dc);
}

CDESIREDoc* CDESIREView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDESIREDoc)));
	return (CDESIREDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDESIREView message handlers

void CDESIREView::OnTransferOk() {

const CString& fpath=GetDocument()->GetPathName() ;
CString ffpath ;
CFile TheFile ;

#if _MFC_VER==0x0400         //    <*********************

                CDESIREView*pWnd=((CDESIREView*)m_viewList.GetHead()) ;
                pWnd->ResetShadowBuffer() ;

#endif					 	//     <*********************


CWaitCursor wait ;

TheFile.Open(".\\syspic.lst",CFile::modeCreate | CFile::modeWrite) ;

if (fpath=="") ffpath="no_name.lst" ; else ffpath=fpath ;

TheFile.Write("/NEW\r\n/\r\n",9) ;

TheFile.Write("/PIC \'",6) ;
TheFile.Write(ffpath,ffpath.GetLength()) ;
TheFile.Write("\'\r\n",3) ;

CArchive Br(&TheFile, CArchive::store) ;

	ASSERT_VALID(this);
	
		WriteToArchive(Br);
	
	ASSERT_VALID(this);

Br.Close() ;
TheFile.Close() ;

#if _MFC_VER==0x0400         //    <*********************

                CDESIREView*pWnd=((CDESIREView*)m_viewList.GetHead()) ;
                pWnd->ResetShadowBuffer() ;

#endif					 	//     <*********************



}


void CDESIREView::OnTransferAddfile() {

CFile TheFile ;

CWaitCursor wait ;


#if _MFC_VER==0x0400         //    <*********************

                CDESIREView*pWnd=((CDESIREView*)m_viewList.GetHead()) ;
                pWnd->ResetShadowBuffer() ;

#endif					 	//     <*********************


		TheFile.Open(".\\syspic.lst",CFile::modeCreate | CFile::modeWrite) ;

CArchive Br(&TheFile, CArchive::store) ;

	ASSERT_VALID(this);
	
		WriteToArchive(Br);
	
	ASSERT_VALID(this);

Br.Close() ;
TheFile.Write("\n",1) ;    //   <***  make sure of newline!
TheFile.Close() ;




#if _MFC_VER==0x0400         //    <*********************

                CDESIREView*pWnd=((CDESIREView*)m_viewList.GetHead()) ;
                pWnd->ResetShadowBuffer() ;

#endif					 	//     <*********************




}


void CDESIREView::ResetShadowBuffer(void) {    			 // <***********
	
	if (m_pShadowBuffer==NULL) m_nShadowSize=0 ;
	}
