// DESIREView.h : interface of the CDESIREView class
//
/////////////////////////////////////////////////////////////////////////////

class CDESIREView : public CEditView
{
protected: // create from serialization only
	CDESIREView();
	DECLARE_DYNCREATE(CDESIREView)

// Attributes
public:
	CDESIREDoc* GetDocument();

// Operations
public:

	void ResetShadowBuffer(void) ;
	
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDESIREView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDESIREView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CDESIREView)
	afx_msg void OnTransferOk();
	afx_msg void OnTransferAddfile();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in DESIREView.cpp
inline CDESIREDoc* CDESIREView::GetDocument()
   { return (CDESIREDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
